# uctb-web 

## 05.06demo

- 已实现基本功能，若要增加新的数据集或模型，仅需按照指定格式传入数据集，并新增数据集&模型选择按钮即可正常运行。
- 地图目前有两个版本，一个是根据区域边界经纬度绘制区域多边形，另一个是根据区域中心点坐标用圆点代表一个区域。



### 程序打开方式


**可视化界面index.html打开方法：**

在命令行里键入：

```python
// python 2.x
python -m SimpleHTTPServer

// python 3.x
python -m http.server
```

这将会为当前目录在8000端口创建一个服务器，可以在浏览器地址栏里输入以下格式的地址来访问已经创建好的服务器：

```
http://localhost:8000/file path
```



### 数据集格式

```json
my_dataset = {
    "TimeRange": ['YYYY-MM-DD', 'YYYY-MM-DD'],
    "TimeFitness": 60, 
    "Node": {
        "TrafficNode": [],
        "TrafficMonthlyInteraction": [],
        "StationInfo": list, # shape [num-of-node, 5], 后三个值分别为区域的纬度、经度、名称
        "POI": []
    },
    "Grid": {
        "TrafficGrid": [],
        "GridLatLng": [],
        "POI": []
    },
    "ExternalFeature": [],
  	"Pred": {
      "loader_id_1": {
        "GroundTruth": list,
        "method": {
          "traffic_data_index": list,
          "TrafficNode": list,
          "rmse": float,
          "mape": float,
          "mae": float
        }
      },
      "loader_id_2": {},
      ...
    }
}
```



该数据集通过执行UCTB内置的函数 ```save_predict_in_dataset``` 和 转换程序 ```ChangePKLtoJSON.py``` 即可得到，转换程序功能即去除冗余数据以及将numpy数组转化为list。

为了添加误差值，在原 ```save_predict_in_dataset``` 函数中新增参数```error```，该参数为一个含有三个误差```RMSE```、```MAPE```、```MAE```的数组。




### 程序介绍


程序目前主要包含7个js文件+1个html文件，分别是：


1.js.js  ```读取数据集（json格式），并赋值给全局变量```

2.global.js  ```全局变量，方便程序调用```

3.SelectDatasets.js  ```数据集选择按钮```

4.SelectModel.js  ```模型选择按钮```

5.polygon.js  ```区域边界经纬度，用于在地图上绘制多边形区域，后续考虑存入数据集文件格式中```

6.map.js  ```绘制地图```

7.line_final.js  ```绘制折线图以及RMSE降序柱状图```

8.myfun.js  ```全局变量值的计算、修改数据集/模型程序自动更新```

8.index.html  ```主程序，可视化网页```




可视化程序分为8个板块：


1.数据集选择区：选择不同城市的数据集

2.数据集选项区：同一城市数据集根据closeness、period、trend值的不同又分为不同子数据集

3.模型选择区：选定子数据集后，选择模型；若该数据集中不包含该模型，将弹出错误提示框

4.地图：每一个圆点代表一个区域，用三种颜色区分节点的不同预测结果（与给定的标准RMSE对比）

- 黑色：无效节点

- 红色：Not Accurate！（节点RMSE>标准RMSE）

- 绿色：Accurate！（节点RMSE<=标准RMSE）

5.模型评估区：列出模型在该数据集上的RMSE、MAE、MAPE

6.操作区：可以选择想要查看的起始结束时间、节点ID、设置标准RMSE以及包含一个highlight按钮

7.折线图：绘制所选区域真实值与预测值

8.RMSE降序柱状图：降序绘制各区域RMSE，点击操作区中的highlight按钮后，将用两种颜色区分各区域RMSE与标准RMSE对比的结果

- 浅粉色：节点RMSE>标准RMSE
- 橙色：节点RMSE<=标准RMSE




### 基本功能

使用时，首先在左上角的Datasets中选择想要查看的数据集，以及对应的模型（程序默认选择第一个子数据集和第一个模型），程序将自动更新，在中间的顶部状态栏可以看到模型在该数据集上的三个评估指标```RMSE```、```MAE```、```MAPE```，并绘制各节点的RMSE降序柱状图。点击地图上的不同圆点，或在操作区的```pointID```框内输入节点序号并按ok确认后，程序将以选中序号的地图节点绘制折线图。点击操作区中的```highlight```按钮，将在折线图上体现出所选节点在每一个时间片上的预测效果（绿色：合格；红色：不合格）。



